/*=============================================================================
   FILE:         Main.cpp
-------------------------------------------------------------------------------
   DESCRIPTION:  WinMain and DlgProc for main dialog
   AUTHOR:       F.M.Birth
   HISTORY:      18-8-1999
   NOTES:        This project does not use MFC !
-------------------------------------------------------------------------------
   COPYRIGHT:    (c) 1999-2005, TerraTec Electronic GmbH. All Rights Reserved.

                 Information in this file is the intellectual property of
                 TerraTec Electronic GmbH, and contains trade secrets
                 that must be stored and viewed confidentially.
                 By viewing, using, modifying and compiling 
                 the programming code below you acknowledge you have read,
                 accepted and executed the Software licensing agreement 
                 your company has established with TerraTec Electronic GmbH.
=============================================================================*/
#ifndef __MAIN_H__
#define __MAIN_H__


#define FREQ_DEF	(99200*ONE_KHZ) // default frequency value after startup

#define VOL_MIN		0
#define VOL_MAX		127
#define VOL_DEF		50

#define STEREO		1
#define MONO		0

#define MODE_DX		1
#define MODE_LOCAL	0 // Attenuation switched on (for too strong signals)

#define RDS_POLLTIME 15 // this parameter for RDS_start is ignored

#define DISPLAY_UPDATE_PERIOD	500	// update display every 500 ms
#define RDS_UPDATE_PERIOD		200	// get actual RDS data every 200 ms


// global Window object
extern CMainWnd Dlg;

BOOL CALLBACK DlgProc(HWND hDlg,UINT uMsg,WPARAM wParam,LPARAM lParam);

void DB(LPSTR lpszDebugString, ...); // Debug Output

#endif //__MAIN_H__
